
class Plato

	attr_reader :titulo, :porcion, :gramos

	def initialize(titulo, porcion, gramos)

		@titulo = titulo
		@porcion = porcion
		@gramos = gramos

	end


	def to_s
		"#{@titulo}, #{@porcion}, #{@gramos}"
	end

end







class Menu

	include Comparable

attr_reader :titulo, :porcentaje, :platos, :vct, :proteinas, :grasas, :hidratos_carbono

	def initialize(titulo, porcentaje, platos, vct, proteinas, grasas, hidratos_carbono)

		@titulo = titulo
		@porcentaje = porcentaje
		@platos = platos
		@vct = vct
		@proteinas = proteinas
		@grasas = grasas
		@hidratos_carbono = hidratos_carbono

	end


	def to_s

		string = "#{@titulo} (#{@porcentaje}) \n"

		for i in (0..@platos.length-1)
			string += "- #{@platos[i]} \n"
		end

		string += "V.C.T | %	#{@vct} kcal | #{@proteinas} - #{@grasas} - #{@hidratos_carbono}"

		string


	end


	def get_titulo
		@titulo.to_s
	end

	def get_porcentaje
		@porcentaje.to_s
	end

	def get_platos
		string=@platos[0].to_s
    for i in (1..@platos.length-1)
      string += @platos[i].to_s
    end
    string
	end

	def get_plato(n_plato)
		platos[n_plato].to_s
	end

	def get_vct
		@vct.to_s+" kcal"
	end

	def get_proteinas
		@proteinas.to_s+"%"
	end

	def get_grasas
		@grasas.to_s+"%"
	end

	def get_hidratos
		@hidratos_carbono.to_s+"%"
	end

	def <=>(other) #Compara dos objetos de la misma jerarquía basandose en la variable calórica vct
	return nil unless other.is_a? Menu
			return @vct <=> other.vct
	end


end


class MenuEdad < Menu

	attr_reader :edad

	def initialize(edad, menu)
		super(menu.titulo,menu.porcentaje,menu.platos, menu.vct, menu.proteinas, menu.grasas, menu.hidratos_carbono)
		@edad = edad


	end

	def to_s

		title = super.to_s + "\nEdad:#{@edad}"
	end


end

class MenuAlimentos < Menu

	attr_reader :alimentos

	def initialize(alimentos, menu)

		super(menu.titulo,menu.porcentaje,menu.platos, menu.vct, menu.proteinas, menu.grasas, menu.hidratos_carbono)
		@alimentos= alimentos

	end

	def to_s

		title = super.to_s + "\nGrupo de alimentos:#{@alimentos}"
	end




end
